open Js_null_undefined

let suites = Mt.[
  "to_opt - null", (fun _ -> Eq(None, null |> to_opt));
  "to_opt - undefined", (fun _ -> Eq(None, undefined |> to_opt));
  "to_opt - empty", (fun _ -> Eq(None, empty |> to_opt));
  "to_opt - 'a", (fun _ -> Eq(Some (), return () |> to_opt));
  "return", (fun _ -> Eq(Some "something", return "something" |> to_opt));
  "test - null", (fun _ -> Eq(true, null |> test));
  "test - undefined", (fun _ -> Eq(true, undefined |> test));
  "test - empty", (fun _ -> Eq(true, empty |> test));
  "test - 'a", (fun _ -> Eq(false, return () |> test));
  "bind - null", (fun _ -> Eq(true, bind null ((fun v -> v) [@bs]) |> test));
  "bind - undefined", (fun _ -> Eq(true, bind undefined ((fun v -> v) [@bs]) |> test));
  "bind - empty", (fun _ -> Eq(true, bind empty ((fun v -> v) [@bs]) |> test));
  "bind - 'a", (fun _ -> Eq(Some 4, bind (return 2) ((fun n -> n * 2) [@bs]) |> to_opt));
  "iter - null", (fun _ ->
    let hit = ref false in
    let _ = iter null ((fun _ -> hit := true) [@bs]) in
    Eq(false, !hit)
  );
  "iter - undefined", (fun _ ->
    let hit = ref false in
    let _ = iter undefined ((fun _ -> hit := true) [@bs]) in
    Eq(false, !hit)
  );
  "iter - empty", (fun _ ->
    let hit = ref false in
    let _ = iter empty ((fun _ -> hit := true) [@bs]) in
    Eq(false, !hit)
  );
  "iter - 'a", (fun _ ->
    let hit = ref 0 in
    let _ = iter (return 2) ((fun v -> hit := v) [@bs]) in
    Eq(2, !hit)
  );
  "from_opt - None", (fun _ -> Eq(undefined, None |> from_opt));
  "from_opt - Some", (fun _ -> Eq(return 2, Some 2 |> from_opt));
  "null <> undefined", (fun _ -> Ok(null <> undefined));
  "null <> empty", (fun _ -> Ok(null <> empty));
  "undefined = empty", (fun _ -> Ok(undefined = empty));
]
;; Mt.from_pair_suites __FILE__ suites
